<?php

namespace FM\Service;

use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\Remote\FileUploader\Server;
use Zeedhi\Framework\Remote\cURLRequest;

class FileServerService
{

    protected $environment;
    protected $fileServerApiKeys;
    protected $fileServerUrl;

    public function __construct(Environment $environment, $fileServerApiKeys, $fileServerUrl)
    {
        $this->environment = $environment;
        $this->fileServerApiKeys = $fileServerApiKeys;
        $this->fileServerUrl = $fileServerUrl;
    }

    public function uploadFiles($params, $customFolder)
    {
        $nrorg = $this->environment->getNrOrg();
        if (isset($this->fileServerApiKeys[$nrorg])) {
            $key = $this->fileServerApiKeys[$nrorg];
            $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
            $row = array('FILE' => $params);
            $zhFileUploader->uploadFilesInRow($row, 'FILE', $customFolder);
            return $row['FILE'];
        } else {
            throw new \Exception("Erro ao anexar documento no FileServer: Não existe chave de API parametrizada para o número de organização informado.");
        }
    }

    public function deleteFile($path)
    {
        $nrorg = $this->environment->getNrOrg();
        $key = $this->fileServerApiKeys[$nrorg];
        $zhFileUploader = new Server(new cURLRequest($this->fileServerUrl . "/index.php"), $key);
        $zhFileUploader->deleteFile($path);
    }

    public function getDocumentoFileServer($urlArquivo, $nrorg)
    {
        $header = array(
            "apiKey: " . $this->fileServerApiKeys[$nrorg]
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $urlArquivo);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 90);

        $resultado = curl_exec($ch);
        $error     = curl_error($ch);
        curl_close($ch);

        if (!empty($error)) {
            throw new \Exception($error);
        }

        if (strpos($resultado, "404 Not Found") !== false) {
            //throw new \Exception($resultado);
            return false;
        } else {
            return $resultado;
        }
    }
}
