import {
    Config, Http, IDictionary, Interceptor,
} from '@zeedhi/core';
import { makeServer, IRouteConfig } from '@zeedhi/zeedhi-miragejs';
import prodEnvironment from '@/config/prodEnvironment.json';
import devEnvironment from '@/config/devEnvironment.json';
import adapter from '@zeedhi/axios-mirage-adapter';
import getMinhasTarefas from './rotas/getMinhasTarefas';
import getItensTarefas from './rotas/getitensTarefas';

const env = process.env.NODE_ENV === 'production' ? prodEnvironment : devEnvironment;

const serverConfig: IDictionary<IRouteConfig<any>> = {
    getItensTarefas,
    getMinhasTarefas,
};

Interceptor.addRequestSuccess((config) => ({ ...config, adapter }));

const server = () => {
    const utilizaCache = false;
    let endPointServer = '';

    if (utilizaCache) {
        Config.endPoint = 'http://teste/mirage';
        endPointServer = Config.endPoint;
    } else {
        endPointServer = env.endPoint;
    }

    Http.setBaseURL(Config.endPoint);
    console.warn(`Rota: ${endPointServer}`);
    makeServer({
        endpoint: endPointServer,
        config: serverConfig,
        persist: true,
        logging: true,
    });
};

export default server;
